# Phoenix Wright, The Ace Attorney

Adds Phoenix Wright to Risk of Rain 2, based off his moveset in Marvel vs Capcom 3.

Network Compatible (Except for one issue that I need to fix)

Created by BokChoyWithSoy. Help me out for bugs and issues by contacting me on discord: BokChoyWithSoy#3842

<img src="https://cdn.discordapp.com/attachments/399901440023330816/927506880002129970/Phoenix_Lobby.png">
  
## Skills

### Passive: Turnabout
#### <img src="https://cdn.discordapp.com/attachments/399901440023330816/927507829273817088/texBuffIcon.png">
<b>Whenever you hit an enemy with Press The Witness while holding a decisive piece of evidence</b>, gain a stack of turnabout, if you have 50 stacks of turnabout, Phoenix will enter turnabout mode,<b> permanently</b> empowering Phoenix's skills.

### Primary: Throw Evidence
<img src="https://cdn.discordapp.com/attachments/399901440023330816/927507210026745956/texServbotIcon.png">
<img src="https://cdn.discordapp.com/attachments/399901440023330816/927507210563645500/texBottleIcon.png">
<img src="https://cdn.discordapp.com/attachments/399901440023330816/927507746725715988/texVaseIcon.png">
<img src="https://cdn.discordapp.com/attachments/399901440023330816/927507211012411392/texKnifeIcon.png">
<img src="https://cdn.discordapp.com/attachments/399901440023330816/927507209640882176/texPhoneIcon.png"><br>
Stunning. Agile. Throw a random piece of evidence, junk will deal 200% damage and decisive evidence will deal 400% damage.

### Turnabout Primary: Take That!
<img src="https://cdn.discordapp.com/attachments/399901440023330816/927509050730614815/texPrimaryUpgrade.png"><br>
Stunning. Agile. Summon a giant hand which travels in a line, dealing 400% damage.

### Secondary: Press The Witness
<img src="https://cdn.discordapp.com/attachments/399901440023330816/927509762449498112/texPressIcon.png"><br>
Stunning. Press the witness, dealing 400% damage. Gain turnabout if you have decisive evidence.

### Turnabout Secondary: Objection!
<img src="https://cdn.discordapp.com/attachments/399901440023330816/927510244827996180/texSecondaryUpgradeIcon.png"><br>
Freezing. Raise an objection, dealing 600% damage.

### Utility: Fall
<img src="https://cdn.discordapp.com/attachments/399901440023330816/927510540060880996/texTripIcon.png"><br>
Stunning. Fall forward on your face gaining 300 armour and dealing 200% damage. You cannot be hit during the fall. Gain an extra charge when In turnabout mode or reset the skill if you have decisive evidence.

### Special: Order In The Court!
<img src="https://cdn.discordapp.com/attachments/399901440023330816/927511214836314142/texGavelIcon.png"><br>
Stunning. After a short delay, a giant gavel falls from the sky dealing 700% damage. You cannot be hit for 2 seconds. Double the range and damage and weaken enemies if you are in turnabout mode or have decisive evidence.

## Support me on Ko-fi
If you like my stupid mod idea, then consider supporting me on ko-fi! <br>
<a href="https://ko-fi.com/bokchoywithsoy">
<img src="https://media.discordapp.net/attachments/399901440023330816/952862894721208330/download.png"><br>
</a>

## Popcorn Factory
<b>Check out other mods from the Popcorn Factory team!</b>
<div>
	<a href="https://thunderstore.io/package/Ethanol10/Ganondorf_Mod/">
		<img src="https://cdn.discordapp.com/attachments/399901440023330816/960043613428011079/Ethanol10-Ganondorf_Mod-2.1.5.png.128x128_q95.png"><br>
		<p>Ganondorf Mod (Ethanol 10)</p>
	</a>
</div>
<div>
	<a href="https://thunderstore.io/package/TeaL/DekuMod/">
		<img src="https://cdn.discordapp.com/attachments/399901440023330816/960043614036168784/TeaL-DekuMod-3.1.1.png.128x128_q95.png"><br>
		<p>Deku Mod (TeaL)</p>
	</a>
</div>
<div>
	<a href="https://thunderstore.io/package/PopcornFactory/Wisp_WarframeSurvivorMod/?utm_source=discord">
		<img src="https://cdn.discordapp.com/attachments/399901440023330816/960043613692239942/PopcornFactory-Wisp_WarframeSurvivorMod-1.0.2.png.128x128_q95.png"><br>
		<p>Wisp Mod (Popcorn Factory Team)</p>
	</a>
</div>

## Changelog

<details open>
  <summary>Click to expand patch notes</summary>

- 1.7.2
	- Turnabout music should be heard by all players now.
	- Fixed an issue where turnabout music would play upon getting a stack of turnabout.

- 1.7.1
	- Fixed an issue where you could not hear some sound effects.
	- Fixed an issue where you could not see some animations.
	- Fixed an issue where jumping and using your secondary would collide with yourself.
	
- 1.7.0
	- Added item displays for the base game.
	- Reduced the proc rates of "Objection In The Court!"
	- Fixed an issue where Fall did not give player invincibility or armour.
	- Fixed an issue where you could earn achievements on any character.
	- Fixed an issue where the turnabout music was not centered on player character.

	<b> BALANCE CHANGES </b>
	- <b>Turnabout Order In The Court!</b> proc rate 5 > proc rate 2
	- <b>Turnabout Order In The Court!</b> Invincibility buff 2 sec > 1 sec

- 1.6.2
	- Fixed an issue where the achievement was lagging out the game.

- 1.6.1
	- Fixed an issue where you could earn achievements on any character.
	- Fixed an issue where secondary skill would collide with the player model.
	
	<b> BALANCE CHANGES </b>
	- <b>Throw Evidence</b> duration 1s > duration 0.75
	- <b>Take That!</b> 600% dmg > 400% dmg
	- <b>Press</b> 600% dmg > 400% dmg
	- <b>Turnabout Press</b> 800% dmg > 600% dmg
	- <b>Fall</b> 300% dmg > 200% dmg
	- <b>Order In The Court!</b> 1000% dmg > 700% dmg
	- <b>Turnabout Order In The Court!</b> 2000% dmg > 1400% dmg
	- <b>Turnabout Order In The Court!</b> 50m > 40m

- 1.6.0
	- Added new skin.
	- Added new Achievement.
	- Fixed running animation snapping to another point.
	- Fixed jump animation snapping to another point.

- 1.5.2
	- Changed running animation
	- Fixed an issue where turnabout gavel would hit allies and self.

- 1.5.1
	- Secondary skill now will collide with the floor when aimed at the floor.
	- Added the ability to cancel other skills into special skill.

- 1.5.0
	- Added new skin.
	- Added new achievement.

- 1.4.5
	- Forgot to reset turnabout stacks to 50 like a dumbass.

- 1.4.4 
	- Achievement issue has been fixed and mastery achievement has ben reenabled. 

- 1.4.3
	- Fixed an issue where the mod was infinitely loading in the loading screen.

- 1.4.2
	- MASTERY ACHIEVEMENT HAS BEEN TEMPORARILY DISABLE DUE TO HAVING ISSUES WITH THE LOGBOOK. (skin is still usable)
	- Added a config which allows for the adjustments of stacks need for turnabout mode. (credits to AcCodo)
	- Fixed network issue where Attorney's special was not applying the invincibility buff.
	- Attorney's utility and special skill is now upgraded when entering turnabout mode.
	- Turnabout skills now display the right name and description when hovering over them in game.
	- Turnabout skills now slightly change in appearance.

- 1.4.1
	- Forgot to change stacks needed for turnabout mode back to 50.

- 1.4.0
	- Updated mod with work with Survivors of The Void DLC.

- 1.3.0
	- Knife primary now applies a bleed stack.
	- Phone primary now applies a shock stack.
	- Secondary will now grant multiple turnabout stacks depending on the amount of enemies hit. (Thanks to Slat on discord for implementation)
	- Secondary config will allow for turnabout to only increment by one. (for people who want a harder challenge)
	- Utility will now reset its cooldown if you have decisive evidence.
	- Special will now have double range and damage and weaken enemies if you have decisive evidence.
	- Updated skill descriptions to reflect skill changes.

- 1.2.6 
	- Added config option to reduce SFX and Voice volume.
	- increased the range you can hear SFX (lowered way too much last update.)

- 1.2.5 
	- Primary attack now stuns briefly.
	- Empowered primary now bypasses armour.
	- Empowered secondary now bypasses armour and freezes.
	- Increased the sound effects volume again (People please stop playing ROR2 on full volume it's not healthy.)

- 1.2.4 
	- Forgot to revert decisive evidence needed for turnabout mode when testing.

- 1.2.3 
	- "Throw Evidence" no longer does absurd knockback.
	- "Take That" no longer does absurd knockback.
	- Turnabout music can now be heard omnidirectionally.
	- Phoenix's death sound can be heard mapwide (Cause it's funny).
	- Significantly reduced the range you can hear Phoenix's voice lines.
	- Significantly reduced the volume of all sound effects.

- 1.2.2 
	- Fixed an issue where Phoenix's voice lines would play in the menu when you picked Sett from the Sett mod (Thanks to Lemonlust for figuring it out)
	- Turnabout music may now be heard by all players in the lobby.

- 1.2.1 
	- Added death animation.
	- Fixed a bug where "Press The Witness" would fire multiple particles in multiplayer.
	- Fixed a bug where "Order In The Court!" would fire multiple times in multiplayer.
	- Increased the size of the hitbox of "Fall"
	- Increased the duration of "Fall" making more consistent to hit.

- 1.2.0
	- Added mastery achievement.
	- Added mastery skin (find out what it is.)
	- Increased the range of "Order In The Court!"
	- Increased the proc rate of "Order In The Court!"
	- Increased the proc rate of "Press The Witness"

- 1.1.2
	- Increased the projectile size of primary attack to improve hitbox consistency.
	- Increased the projectile size of the turnabout primary attack to improve hitbox consistency.
	- Turnabout stacks now reset in multiplayer when starting a new run.
	- "Order In The Court!" now makes the character invincible for a short duration to enourage use of it without dying immediately. 
	- Added the ability to use "Press" while using your primary fire.
	- Added symbols to primary icons to make them colourblind friendly.
	- Improved the throwing animation to make it look a lot less scuffed.

	
- 1.1.1
	- Reduced the volume of all voice and sound effects.
	- Reduced the range in which you hear voice and sound effects.
	- Added keywords to skill descriptions to make them easier to read.
	- Changed in game character name to "Attorney" to conform better with the naming scheme of the game.
	- Gaining a stack of turnabout will automatically reroll into junk evidence so you may no longer roll into another decisive evidence.
	- Increased projectile speed of "Take That!".
	- "Order In The Court!" now screen shakes for effect.
	- Increased duration of armour and invincibility for "Fall" to increase survivability.

- 1.1.0
	- Added sounds all of Phoenix's skills.
	- Added sounds when gaining turnabout stacks.
	- Added music when you enter turnabout mode.

- 1.0.2
	- Fixed a bug where switching levels reset the empowered primary and secondary skill to the base states.
	- Fixed a bug where turnabout stacks did not reset upon starting a new game.

- 1.0.1
	- Fixed a bug where turnabout stacks were not working if you were not the host of the game.
	- Fixed a bug where your primary attack did not shuffle to a new item if you were playing muliplayer.

- 1.0.0
	- Initial Release


</details>
 
## Future Plans
- Implement new skills
- Fix some bugs (in Known issues)
- Add stand alone scepter support
- add displays from SOTV
- New skins
- New achievements
- Clean up the atrocity that I call code

## Known Issues
- In multiplayer, for some goddamn reason, the normal primary spawns the prefab of the empowered primary and you have people throwing arms around, this problem only exists for clients.

## Credits
- Rob's HenryMod -> prevented me from experiencing excruciating pain
- Lemonlust -> bug fixing and code from Sett mod.
- Capcom -> Model & Texturing
- Mixamo -> Animations
- TheTimesweeper -> Hitbox viewer was extremely helpful
- KingEnderBrine -> I love you for making the item placer helper.
- TeaL & Ethanol 10 -> Other members of Popcorn Factory who helped me out.
- The vast amount of Vtuber streams I watched while coding which kept me sane.
